<template>
  <ele-modal
    custom-class="ele-dialog-form long-dialog-form"
    :centered="true"
    :visible.sync="visible"
    :title="title"
    append-to-body
    :close-on-click-modal="false"
    width="85%"
    :maxable="true"
  >
    <el-card shadow="never">
      <header-title title="物品信息"></header-title>
      <el-form
        label-width="100px"
        ref="form"
        :model="rowData"
        class="item-height"
      >
        <el-row>
          <el-col :span="6" label-width="100px">
            <el-form-item label="名称" prop="name">
              <el-input
                disabled
                placeholder="物品名称"
                v-model="treeData.name"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6" label-width="100px">
            <el-form-item label="编码" prop="code">
              <el-input
                disabled
                placeholder="物品编码"
                v-model="treeData.code"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6" label-width="100px">
            <el-form-item label="型号" prop="modelType">
              <el-input
                disabled
                placeholder="物品型号"
                v-model="treeData.modelType"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6" label-width="100px">
            <el-form-item label="规格" prop="specification">
              <el-input
                disabled
                placeholder="物品规格"
                v-model="treeData.specification"
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>

      <header-title title="工序信息"></header-title>
      <el-form label-width="100px" ref="form" :model="rowData">
        <el-row>
          <el-col :span="6" label-width="100px">
            <el-form-item label="编码" prop="type">
              <el-input
                disabled
                placeholder="工序编码"
                v-model="rowData.code"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6" label-width="100px">
            <el-form-item label="工序名称" prop="type">
              <el-input
                disabled
                placeholder="工序名称"
                v-model="rowData.name"
              ></el-input>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="6" label-width="100px">
            <el-form-item label="名称" prop="type">
              <el-input
                disabled
                placeholder="物品名称"
                v-model="rowData.name"
              ></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6" label-width="100px">
            <el-form-item label="物品编码" prop="type">
              <el-input
                disabled
                placeholder="工序名称"
                v-model="rowData.name"
              ></el-input>
            </el-form-item>
          </el-col> -->
        </el-row>
      </el-form>

      <el-tabs
        v-model="activeName"
        class="tab-box"
        type="border-card"
        @tab-click="tabsChange"
      >
        <el-tab-pane label="工艺参数" name="工艺参数">
          <ele-pro-table
            ref="table"
            :datasource="datasource"
            :immediate="true"
            :need-page="false"
            :columns="columns"
          >
            <!-- 表头工具栏 -->
            <template v-if="!isView" v-slot:toolbar>
              <el-button
                size="small"
                icon="el-icon-plus"
                class="ele-btn-icon"
                type="primary"
                @click.native="openParam('工艺')"
                >添加参数</el-button
              >
            </template>

            <template v-slot:sort="{ row }">
              <div v-if="isView">{{ row.sort }}</div>
              <el-input v-else v-model="row.sort"></el-input>
            </template>

            <!-- 默认值 -->
            <template v-slot:defaultValue="{ row }">
              <div v-if="isView">
                {{ row.defaultValue }}
              </div>
              <div v-else>
                <el-input
                  v-if="
                    row.textType == 1 ||
                    row.textType == 4 ||
                    row.textType == 3 ||
                    row.textType == 5
                  "
                  v-model="row.defaultValue"
                  placeholder="请输入"
                ></el-input>
                <el-select
                  v-if="row.textType == 2"
                  v-model="row.defaultValue"
                  placeholder="请选择"
                >
                  <el-option label="TRUE" :value="'TRUE'" />
                  <el-option label="FALSE" :value="'FALSE'" />
                </el-select>
              </div>
            </template>

            <!-- 上限 -->
            <template v-slot:maxValue="{ row }">
              <div v-if="isView">
                {{ row.maxValue }}
              </div>
              <div v-else>
                <el-input
                  v-if="row.textType == 3"
                  v-model="row.maxValue"
                  placeholder="请输入"
                ></el-input>
              </div>
            </template>
            <!-- 下限 -->
            <template v-slot:minValue="{ row }">
              <div v-if="isView">
                {{ row.minValue }}
              </div>
              <div v-else>
                <el-input
                  v-if="row.textType == 3"
                  v-model="row.minValue"
                  placeholder="请输入"
                ></el-input>
              </div>
            </template>

            <!-- 单位 -->
            <template v-slot:unitName="{ row }">
              <div v-if="isView">
                {{ row.unitName }}
              </div>
              <div v-else>
                <DictSelection
                  v-if="row.textType != 2 && row.textType != 5"
                  dictName="工艺参数单位"
                  clearable
                  filterable
                  v-model="row.unitName"
                >
                </DictSelection>
                <span v-if="row.textType == 5"> h(小时)</span>
              </div>
            </template>

            <!-- 操作列 -->
            <template v-slot:action="{ row }">
              <el-popconfirm
                class="ele-action"
                title="确定要删除当前参数吗？"
                @confirm="remove(row, '工艺')"
              >
                <template v-slot:reference>
                  <el-link
                    type="danger"
                    :underline="false"
                    icon="el-icon-delete"
                  >
                    删除
                  </el-link>
                </template>
              </el-popconfirm>
            </template>
          </ele-pro-table>
        </el-tab-pane>
        <el-tab-pane label="质检项参数" name="质检项参数">
          <term
            :qualityParam="qualityParam"
            :isView="isView"
            ref="qualityParamRef"
          ></term>
        </el-tab-pane>
        <el-tab-pane label="生产节拍" name="生产节拍">
          <el-form
            label-width="140px"
            ref="form"
            :model="beatParam"
            style="width: 800px; margin: auto"
          >
            <el-row>
              <el-col :span="16" label-width="100px">
                <el-form-item label="节拍生产数量" prop="beatNum">
                  <el-input
                    v-if="!isView"
                    placeholder=""
                    v-model="beatParam.beatNum"
                    maxlength="9"
                  ></el-input>
                  <div v-else>{{ beatParam.beatNum }}</div>
                </el-form-item>
              </el-col>

              <el-col :span="8" label-width="100px">
                <el-form-item label="单位：" prop="unit">
                  <el-select
                    v-if="!isView"
                    v-model="beatParam.unit"
                    filterable
                    class="ele-block"
                    @change="changeUnit"
                  >
                    <el-option
                      v-for="item in dictList"
                      :key="item.value"
                      :value="item.value"
                      :label="item.label"
                    ></el-option>
                  </el-select>
                  <div v-else>{{ beatParam.unit }}</div>
                </el-form-item>
              </el-col>
            </el-row>

            <el-row>
              <el-col :span="16" label-width="100px">
                <el-form-item label="生产时长" prop="newBeatTime">
                  <el-input
                    v-if="!isView"
                    placeholder=""
                    v-model="beatParam.newBeatTime"
                    @blur="convertVal(beatParam.newBeatTime, 'beatTime')"
                    maxlength="9"
                    oninput="value = value.replace(/[^\d.]/g, '')"
                  ></el-input>

                  <div v-else>{{ beatParam.newBeatTime }}</div>
                </el-form-item>
              </el-col>

              <el-col :span="8" label-width="100px">
                <el-form-item label="单位：" prop="">
                  <div>{{ beatParam.unit }}</div>
                </el-form-item>
              </el-col>
            </el-row>
            <el-row>
              <el-col :span="16" label-width="100px">
                <el-form-item label="准备时长" prop="newBeatPrepareTime">
                  <el-input
                    v-if="!isView"
                    placeholder=""
                    v-model="beatParam.newBeatPrepareTime"
                    @blur="
                      convertVal(
                        beatParam.newBeatPrepareTime,
                        'beatPrepareTime'
                      )
                    "
                    maxlength="9"
                    oninput="value = value.replace(/[^\d.]/g, '')"
                  ></el-input>
                  <div v-else>{{ beatParam.newBeatPrepareTime }}</div>
                </el-form-item>
              </el-col>

              <el-col :span="8" label-width="100px">
                <el-form-item label="单位：" prop="">
                  <div>{{ beatParam.unit }}</div>
                </el-form-item>
              </el-col>
            </el-row>
            <el-row>
              <el-col :span="16" label-width="140px">
                <el-form-item label="下道工序间隔时长" prop="newBeatRestTime">
                  <el-input
                    v-if="!isView"
                    placeholder=""
                    v-model="beatParam.newBeatRestTime"
                    @blur="
                      convertVal(beatParam.newBeatRestTime, 'beatRestTime')
                    "
                    maxlength="9"
                    oninput="value = value.replace(/[^\d.]/g, '')"
                  ></el-input>
                  <div v-else>{{ beatParam.newBeatRestTime }}</div>
                </el-form-item>
              </el-col>

              <el-col :span="8" label-width="100px">
                <el-form-item label="单位：" prop="beatRestUnit">
                  <div>{{ beatParam.unit }}</div>
                </el-form-item>
              </el-col>
            </el-row>

            <el-row>
              <el-col :span="16" label-width="100px">
                <el-form-item label="标准时长" prop="newTime">
                  <el-input
                    v-if="!isView"
                    placeholder="标准时长"
                    v-model="beatParam.newTime"
                    @blur="convertVal(beatParam.newTime, 'time')"
                    maxlength="9"
                    oninput="value = value.replace(/[^\d.]/g, '')"
                  ></el-input>
                  <div v-else>{{ beatParam.newTime }}</div>
                </el-form-item>
              </el-col>
              <el-col :span="8" label-width="100px">
                <el-form-item label="单位：" prop="">
                  <div>{{ beatParam.unit }}</div>
                </el-form-item>
              </el-col>
            </el-row>

            <el-row>
              <el-col :span="16" label-width="100px">
                <el-form-item label="工时单价" prop="taskPrice">
                  <el-input
                    v-if="!isView"
                    placeholder=""
                    v-model="beatParam.taskPrice"
                    oninput="value = value.replace(/[^\d.]/g, '')"
                    maxlength="7"
                  ></el-input>
                  <div v-else>{{ beatParam.taskPrice }}</div>
                </el-form-item>
              </el-col>
              <el-col :span="8" label-width="100px">
                <el-form-item label="单位：" prop="">
                  <div>元</div>
                </el-form-item>
              </el-col>
            </el-row>

            <el-row>
              <el-col :span="24" label-width="100px">
                <el-form-item label="备注" prop="remark">
                  <el-input
                    v-if="!isView"
                    placeholder=""
                    v-model="beatParam.remark"
                    type="textarea"
                    :rows="4"
                  ></el-input>
                  <div v-else>{{ beatParam.remark }}</div>
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </el-tab-pane>

        <el-tab-pane label="材料定额" name="材料定额">
          <ele-pro-table
            ref="materialTable"
            :columns="columns1"
            :datasource="datasource"
            :need-page="false"
            :immediate="true"
          >
            <!-- 表头工具栏 -->
            <template v-slot:toolbar>
              <el-button type="primary" v-if="!isView" @click="add"
                >添加</el-button
              >
              <el-button type="primary" v-if="!isView" @click="detailsList"
                >从明细表导入</el-button
              >
              <div class="toolbar_box">
                <div>
                  <el-form
                    ref="form"
                    :rules="rules"
                    :model="form"
                    label-width="80px"
                    inline
                  >
                    <el-form-item prop="baseCount" label="基本数量">
                      <el-input
                        placeholder="请输入"
                        :disabled="isView"
                        v-model.number="form.baseCount"
                      >
                      </el-input>
                    </el-form-item>

                    <el-form-item prop="baseCountUnit" label="单位">
                      <!-- <DictSelection
                        dictName="计量单位"
                        clearable
                        :disabled="true"
                        v-model="form.baseCountUnit"
                      ></DictSelection> -->
                      <!-- <el-form-item label="单位：" prop="unit"> -->
                      <el-select
                        disabled
                        v-model="form.baseCountUnit"
                        filterable
                        class="ele-block"
                        @change="changeUnit"
                      >
                        <el-option
                          v-for="item in unitList"
                          :key="item.value"
                          :value="item.value"
                          :label="item.label"
                        ></el-option>
                      </el-select>
                      <!-- </el-form-item> -->
                    </el-form-item>
                  </el-form>
                </div>
              </div>
            </template>
            <template v-slot:action="{ row, $index }">
              <el-link type="danger" @click="handleDel(row, $index)"
                >删除</el-link
              >
              <el-link type="primary" @click="handSubstitution(row)"
                >替代料</el-link
              >
            </template>
            <template v-slot:subCode="{ row }">
              <div v-if="isView">{{ row.subCode }}</div>
              <el-input
                v-else
                v-model="row.subCode"
                placeholder="请输入"
              ></el-input>
            </template>

            <template v-slot:isReworkBom="{ row }">
              <div v-if="isView">{{ isReworkBom[row.isReworkBom] }}</div>
              <div v-else>
                <el-select v-model="row.isReworkBom">
                  <el-option
                    v-for="item in isReworkBomList"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value"
                  >
                  </el-option>
                </el-select>
              </div>
            </template>

            <template v-slot:unit="{ row }">
              <div v-if="isView">{{ row.unit }}</div>
              <div v-else>
                <DictSelection
                  dictName="计量单位"
                  :isProhibit="true"
                  v-model="row.unit"
                ></DictSelection>
              </div>
            </template>

            <template v-slot:count="{ row }">
              <div v-if="isView">{{ row.count }}</div>
              <el-input
                v-else
                v-model="row.count"
                placeholder="请输入"
                style="width: 90px"
                @input="handleInput(row)"
              ></el-input>
            </template>

            <template v-slot:categoryName="{ row, $index }">
              <el-link
                type="primary"
                :underline="false"
                @click="handSubstitution(row)"
                v-if="isView"
                >{{ row.categoryName }}</el-link
              >
              <div v-else
                ><el-input
                  :value="row.categoryName"
                  placeholder="请选择"
                  @click.native="categorySelect(row, $index)"
                ></el-input
              ></div>
            </template>

            <template v-slot:bomArtFiles="{ row }">
              <fileMain v-model="row.bomArtFiles" type="add" size="mini" />
            </template>

            <template v-slot:remark="{ row }">
              <div v-if="isView">{{ row.remark }}</div>
              <el-input
                v-else
                v-model="row.remark"
                placeholder="请输入"
              ></el-input>
            </template>
          </ele-pro-table>
        </el-tab-pane>

        <el-tab-pane label="关键设备" name="关键设备">
          <ele-pro-table
            ref="deviceTabRef"
            :columns="standardCol"
            :datasource="datasource"
            :need-page="false"
            :immediate="true"
          >
            <!-- 表头工具栏 -->
            <template v-if="!isView" v-slot:toolbar>
              <el-button type="primary" @click="add">添加</el-button>
            </template>
            <template v-slot:action="{ row, $index }">
              <el-link type="danger" @click="handleDel(row, $index)"
                >删除</el-link
              >
            </template>
          </ele-pro-table>
        </el-tab-pane>

        <el-tab-pane label="制造资源" name="制造资源">
          <ele-pro-table
            ref="resourceTable"
            :columns="columns1"
            :datasource="datasource"
            :need-page="false"
            :immediate="true"
          >
            <!-- 表头工具栏 -->
            <template v-if="!isView" v-slot:toolbar>
              <el-button type="primary" @click="add">添加</el-button>
            </template>
            <template v-slot:action="{ row, $index }">
              <el-link type="primary" @click="handleDel(row, $index)"
                >删除</el-link
              >
            </template>
            <template v-slot:subCode="{ row }">
              <div v-if="isView">{{ row.subCode }}</div>
              <el-input
                v-else
                v-model="row.subCode"
                placeholder="请输入"
              ></el-input>
            </template>

            <template v-slot:isReworkBom="{ row }">
              <div v-if="isView">{{ isReworkBom[row.isReworkBom] }}</div>
              <div v-else>
                <el-select v-model="row.isReworkBom">
                  <el-option
                    v-for="item in isReworkBomList"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value"
                  >
                  </el-option>
                </el-select>
              </div>
            </template>

            <template v-slot:unit="{ row }">
              <div v-if="isView">{{ row.unit }}</div>
              <div v-else>
                <DictSelection
                  dictName="计量单位"
                  v-model="row.unit"
                ></DictSelection>
              </div>
            </template>

            <template v-slot:count="{ row }">
              <div v-if="isView">{{ row.count }}</div>
              <el-input
                v-else
                v-model="row.count"
                placeholder="请输入"
                @input="
                  (value) =>
                    (row.count = value.replace(
                      /^(-)*(\d+)\.(\d\d\d\d\d\d).*$/,
                      '$1$2.$3'
                    ))
                "
              ></el-input>
            </template>

            <template v-slot:categoryName="{ row, $index }">
              <div v-if="isView">{{ row.categoryName }}</div>
              <div v-else
                ><el-input
                  :value="row.categoryName"
                  placeholder="请选择"
                  @click.native="categorySelect(row, $index)"
                ></el-input
              ></div>
            </template>

            <template v-slot:bomArtFiles="{ row }">
              <fileUpload v-model="row.bomArtFiles" type="add" size="mini" />
            </template>

            <template v-slot:remark="{ row }">
              <div v-if="isView">{{ row.remark }}</div>
              <el-input
                v-else
                v-model="row.remark"
                placeholder="请输入"
              ></el-input>
            </template>
          </ele-pro-table>
        </el-tab-pane>

        <el-tab-pane label="工种" name="工种">
          <ele-pro-table
            ref="jobTable"
            :columns="jobColumns"
            :datasource="datasource"
            row-key="id"
          >
            <!-- 表头工具栏 -->
            <!-- <template v-slot:toolbar>
              <el-button
                size="small"
                type="primary"
                icon="el-icon-plus"
                class="ele-btn-icon"
                @click="addJob"
                >新增</el-button
              >
            </template>
            <template v-slot:action="{ row, $index }">
              <el-link type="primary" @click="handleDel(row, $index)"
                >删除</el-link
              >
            </template> -->
          </ele-pro-table>
        </el-tab-pane>
        <el-tab-pane label="工艺文件" name="工艺文件">
          <ele-pro-table
            ref="fileTable"
            :columns="jobColumns1"
            :datasource="datasource"
            :need-page="false"
            :immediate="true"
          >
            <!-- 表头工具栏 -->
            <template v-if="!isView" v-slot:toolbar>
              <el-button type="primary" @click="addFile">添加</el-button>
            </template>
            <template v-slot:action="{ row, $index }">
              <el-link type="primary" @click="handleDel(row, $index)"
                >删除</el-link
              >
              <el-link type="primary" @click="fileDetails(row)">详情</el-link>
            </template>
          </ele-pro-table>
        </el-tab-pane>

        <el-tab-pane label="标准产出" name="标准产出">
          <ele-pro-table
            ref="standard"
            :columns="standardCol"
            :datasource="datasource"
            :need-page="false"
            :immediate="true"
          >
            <!-- 表头工具栏 -->
            <template v-if="!isView" v-slot:toolbar>
              <el-button type="primary" @click="add">添加</el-button>
            </template>
            <template v-slot:action="{ row, $index }">
              <el-link type="danger" @click="handleDel(row, $index)"
                >删除</el-link
              >
            </template>
          </ele-pro-table>
        </el-tab-pane>
      </el-tabs>
    </el-card>
    <!-- 选择工艺参数 -->
    <jobDialog ref="jobRef" @chooseModal="chooseJob"></jobDialog>
    <ParamModal ref="paramRefs" @chooseModal="chooseModal"></ParamModal>
    <ProductModal ref="productRefs" @changeProduct="determineChoose" />
    <ProductModalMultiple
      ref="productMultipleRefs"
      @selection="addProductList"
    ></ProductModalMultiple>

    <standardOutput
      ref="standardOutputRefs"
      @selection="chooseStandardList"
    ></standardOutput>

    <fileIndex v-if="fileShow" @close="fileClose"></fileIndex>

    <fileBrowse ref="browseRef"></fileBrowse>

    <replaceMaterialPop
      ref="replaceMaterialRef"
      @selected="replaceSelected"
      :isView="isView"
    ></replaceMaterialPop>

    <mbomDatailList ref="bomDetailList"></mbomDatailList>

    <div class="btns">
      <el-button
        type="primary"
        size="small"
        v-if="!isView"
        @click="save('save')"
      >
        保存</el-button
      >

      <el-button type="primary" size="small" @click="save('close')">{{
        isView ? '确定' : '保存并关闭'
      }}</el-button>
      <el-button size="small" @click="handleClose">关闭</el-button>
    </div>
  </ele-modal>
</template>

<script>
  import dictMixins from '@/mixins/dictMixins';
  import * as dayjs from 'dayjs';
  import { getFile } from '@/api/system/file';
  // import fileUpload from '@/components/addDoc/index.vue';
  import {
    workingProcedureUpdate,
    getBomGetById,
    getDetailList,
    newFilePageAPI
  } from '@/api/produce/bom.js';
  import ParamModal from './ParamModal.vue';
  import ProductModal from './ProductModal.vue';
  import { getByCode } from '@/api/system/dictionary-data';
  import ProductModalMultiple from './ProductModalMultiple.vue';
  import userSearch from './user-search.vue';
  import jobDialog from './jobDialog.vue';
  import standardOutput from './standardOutput.vue';
  import term from '../qualityTesting/term';
  import fileIndex from '../file/index.vue';
  import fileBrowse from '../file/fileBrowse.vue';
  import replaceMaterialPop from './replaceMaterialPop.vue';
  // import { newFilePageAPI } from '@/api/produce/bom.js';
  // import { getBomGetById, getDetailList } from '@/api/produce/bom.js';
  import mbomDatailList from './mbomDatailList.vue';
  export default {
    components: {
      userSearch,
      ParamModal,
      // fileUpload,
      ProductModal,
      jobDialog,
      ProductModalMultiple,
      standardOutput,
      term,
      fileIndex,
      fileBrowse,
      replaceMaterialPop,
      mbomDatailList
    },
    mixins: [dictMixins],
    data() {
      return {
        rules: {
          baseCount: [
            { required: true, message: '请输入基本数量', trigger: 'blur' }
          ],
          baseCountUnit: [
            { required: true, message: '请选择单位', trigger: 'change' }
          ]
        },
        form: {
          baseCount: 0,
          baseCountUnit: ''
        },
        baseCountUnit: '',
        baseCount2: '',
        baseCountUnit2: '',
        isView: false,
        filedList: [],
        jobFiledList: [],
        activeName: '工艺参数',
        attributeData: {},
        visible: false,
        title: '配置',
        statusOption: [
          {
            label: '启用',
            value: 1
          },
          {
            label: '停用',
            value: 0
          }
        ],
        isReworkBom: ['否', '是'],
        isReworkBomList: [
          { label: '否', value: 0 },
          { label: '是', value: 1 }
        ],

        dictList: [], //单位下拉

        // 表格列配置
        columns1: [],
        defaultColumns1: [
          {
            type: 'index',
            width: 55,
            align: 'center'
          },
          {
            label: '子项编号',
            prop: 'subCode',
            slot: 'subCode',
            action: 'subCode'
          },
          {
            label: '物料名称',
            prop: 'categoryName',
            slot: 'categoryName',
            action: 'categoryName'
          },
          {
            label: '是否回收料',
            prop: 'isReworkBom',
            slot: 'isReworkBom',
            action: 'isReworkBom'
          },
          {
            label: '编码',
            prop: 'categoryCode'
          },
          {
            label: '牌号',
            prop: 'brandNum'
          },
          {
            label: '型号',
            prop: 'modelType'
          },
          {
            prop: 'specification',
            label: '规格',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            label: '数量',
            slot: 'count',
            action: 'count'
          },
          {
            label: '单位',
            slot: 'unit',
            action: 'unit'
          },

          {
            label: '附件',
            slot: 'bomArtFiles',
            action: 'bomArtFiles',
            minWidth: 150
          },

          {
            label: '备注',
            slot: 'remark',
            action: 'remark'
          }
        ],
        columns: [],
        // 表格列配置
        defaultColumns: [
          {
            prop: 'sort',
            slot: 'sort',
            label: '排序',
            minWidth: 60
          },
          {
            prop: 'code',
            label: '参数编码',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110
          },
          {
            prop: 'name',
            label: '参数名称',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110
          },
          {
            align: 'center',
            prop: 'description',
            label: '文本描述',
            showOverflowTooltip: true,
            minWidth: 110
          },

          {
            prop: 'maxValue',
            slot: 'maxValue',
            label: '参数上限',
            align: 'center'
          },
          {
            prop: 'minValue',
            slot: 'minValue',
            label: '参数下限',
            align: 'center'
          },
          {
            prop: 'defaultValue',
            slot: 'defaultValue',
            label: '默认值',
            align: 'center'
          }
        ],
        levelOptions: [
          {
            label: '初级',
            value: '1'
          },
          {
            label: '中级',
            value: '2'
          },
          {
            label: '高级',
            value: '3'
          }
        ],
        // 表格列配置
        jobColumns: [
          {
            label: '序号',
            type: 'index',
            width: 55,
            align: 'center'
          },
          {
            slot: 'type',
            label: '类型',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110,
            formatter: (_row) => {
              return this.getDictValue('工种类型', _row.type);
            }
          },
          {
            align: 'center',
            prop: 'code',
            label: '编码',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            slot: 'name',
            prop: 'name',
            label: '名称',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110
          },
          {
            slot: 'level',
            prop: 'level',
            label: '等级',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110,
            formatter: (_row) => {
              return this.levelOptions.filter(
                (item) => _row.level == item.value
              )[0].label;
            }
          },
          {
            slot: 'hourCost',
            prop: 'hourCost',
            label: '标准工时费',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 260,
            align: 'center',
            resizable: false,
            slot: 'action',
            showOverflowTooltip: true
          }
        ],
        // 表格选中数据
        jobColumns1: [
          {
            label: '编码',
            prop: 'code',
            width: 180,
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: 'name',
            label: '文档名称',
            align: 'center',
            slot: 'name',
            showOverflowTooltip: true,
            minWidth: 200
          },

          {
            prop: 'storagePath',
            label: '文件名称',
            align: 'center',

            showOverflowTooltip: true,
            minWidth: 200,
            formatter: (_row, _column, cellValue) => {
              return cellValue[0]?.name;
            }
          },

          {
            prop: 'version',
            label: '版本',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 100
          },

          {
            prop: 'createTime',
            label: '创建时间',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 110
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 260,
            align: 'center',
            resizable: false,
            slot: 'action',
            showOverflowTooltip: true
          }
        ],

        standardCol: [
          {
            prop: 'code',
            label: '编码'
          },
          {
            prop: 'name',
            label: '名称',
            showOverflowTooltip: true
          },
          {
            prop: 'brandNum',
            label: '牌号'
          },

          {
            prop: 'modelType',
            label: '型号',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            prop: 'specification',
            label: '规格',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            prop: 'measuringUnit',
            label: '计量单位',
            showOverflowTooltip: true,
            minWidth: 90
          },

          {
            columnKey: 'action',
            label: '操作',
            align: 'center',
            resizable: false,
            slot: 'action',
            showOverflowTooltip: true
          }
        ],

        rowData: {},
        treeData: {},
        currentIndex: 0,
        tableData: {},
        beatParam: {
          newTime: '',
          time: '',
          newBeatPrepareTime: '',
          beatPrepareTime: '',
          newBeatTime: '',
          beatTime: '',
          newBeatRestTime: '',
          beatRestTime: '',
          taskPrice: ''
        },

        qualityParam: [],
        qualityPointParam: [],

        fileShow: false,
        resourceBomId: '',
        level: '',
        attributeData: {},
        unitList: []
      };
    },
    created() {
      this.requestDict('工种类型');
      this.getDictList('time_unit');
      this.getDicTUnitList('measuring_uint');
    },
    methods: {
      addFile() {
        this.fileShow = true;
      },
      fileClose(val) {
        if (val == false) {
          this.fileShow = false;
        } else {
          this.fileShow = false;

          this.$refs.fileTable.setData([
            ...val,
            ...this.$refs.fileTable.getData()
          ]);
          this.$set(
            this.tableData.taskParam[this.currentIndex],
            'fileParam',
            this.$refs.fileTable.getData()
          );
        }
      },

      async getDicTUnitList(code) {
        let { data: res } = await getByCode(code);

        this.unitList = res.reduce((acc, curr) => {
          let key = Object.keys(curr)[0]; // 获取当前对象的键
          let value = curr[key]; // 获取当前对象的值
          acc.push({ value, label: value }); // 将 { value, label } 格式的对象添加到数组中
          return acc;
        }, []); // 初始值为空数组 []

        console.log(this.unitList, 'this.unitList');
      },

      handleInput(item) {
        let newVal = item.count.replace(/[^\d.]/g, '');

        // 2. 不能以点开头
        if (newVal.startsWith('.')) {
          newVal = '';
        }

        // 3. 只允许出现一个小数点
        const firstDotIndex = newVal.indexOf('.');
        if (firstDotIndex !== -1) {
          newVal =
            newVal.slice(0, firstDotIndex + 1) +
            newVal.slice(firstDotIndex + 1).replace(/\./g, '');
        }

        // 4. 更新数据
        item.count = newVal;
      },

      async detailsList() {
        console.log(this.rowData, 'this.rowData');
        await getDetailList({
          bomType: this.attributeData.bomType,
          bomCategoryId: this.resourceBomId,
          taskId: this.rowData.id
        }).then((res) => {
          console.log(res);
          this.$refs.materialTable.setData(res.data);

          this.tableData.taskParam[this.currentIndex].materialQuota = res.data;

          console.log(this.tableData, 'this.tableData');
        });
        // this.$refs.bomDetailList.open(this.resourceBomId, this.level)
      },

      fileDetails(row) {
        this.$refs.browseRef.setFileUrl(row);
      },
      addJob() {
        this.$refs.jobRef.open();
      },
      chooseJob(data) {
        this.$refs.jobTable.setData([
          ...data,
          ...this.$refs.jobTable.getData()
        ]);
        this.$set(
          this.tableData.taskParam[this.currentIndex],
          'aptitudeParam',
          this.$refs.jobTable.getData()
        );
      },
      determineChoose(title, row, idx) {
        let type = '';
        if (this.activeName === '材料定额') {
          type = 'materialQuota';
        } else if (this.activeName === '制造资源') {
          type = 'resource';
        }

        if (title == '选择物料') {
          console.log(row, 'row');
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'categoryName',
            row.name
          );
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'categoryId',
            row.id
          );
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'categoryCode',
            row.code
          );
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'unit',
            row.measuringUnit
          );
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'weightUnit',
            row.weightUnit
          );
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'brandNum',
            row.brandNum
          );
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'modelType',
            row.modelType
          );
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'rootCategoryLevelId',
            row.categoryLevelPathIdParent
          );
          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'specification',
            row.specification
          );

          this.$set(
            this.tableData.taskParam[this.currentIndex][type][idx],
            'id',
            row.id
          );
        }
      },
      uploadedSuccess(data, row) {
        row.bomArtFiles = data[0].storePath;
        this.filedList = [];
      },
      uploadedJobSuccess(data, row) {
        row.path = data[0].storePath;
        row.name = data[0].name;
        this.jobFiledList = [];
      },
      downloadFile(url) {
        getFile({ objectName: url }, '附件');
      },
      categorySelect(row, idx) {
        this.$refs.productRefs.open(row, '选择物料', '1', idx);
      },
      handleDel(row, index) {
        let type = '';
        if (this.activeName === '材料定额') {
          type = 'materialQuota';
        } else if (this.activeName === '制造资源') {
          type = 'resource';
        } else if (this.activeName === '工种') {
          type = 'aptitudeParam';
        } else if (this.activeName === '工艺文件') {
          type = 'fileParam';
        } else if (this.activeName === '标准产出') {
          type = 'standardOutput';
        } else if (this.activeName === '关键设备') {
          type = 'standardDevice';
        }

        this.tableData.taskParam[this.currentIndex][type].splice(index, 1);
      },
      addProductList(list) {
        let subCode = 0;
        let array = [];
        list.map((item, index) => {
          let max = '';
          if (
            this.tableData.taskParam[this.currentIndex]['materialQuota']
              .length > 0
          ) {
            max =
              Math.max(
                ...this.tableData.taskParam[this.currentIndex][
                  'materialQuota'
                ].map((i) => i.subCode)
              ) +
              10 * ++index +
              '';

            if (max.length < 4) {
              max = new Array(4 - max.length).fill('0').join('') + max;
            }
          } else {
            max = 10 * ++index + '';
            if (max.length < 4) {
              max = new Array(4 - max.length).fill('0').join('') + max;
            }
          }

          console.log('item', this.isValueANumber(item.specification));

          if (
            item.categoryLevelPathIdParent == 8 &&
            this.isValueANumber(this.baseCount) &&
            this.isValueANumber(item.specification)
          ) {
            let num = this.baseCount / item.specification;
            item.count = num == 'Infinity' ? '' : num.toFixed(3);
          }

          subCode = max.substring(0, max.length - 1) + '0';
          array.push({
            subCode,
            id: item.id,
            categoryName: item.name,
            categoryCode: item.code,
            isReworkBom: 0,
            brandNum: item.brandNum,
            count: item.count || '',
            modelType: item.modelType,
            unit: item.measuringUnit,
            bomArtFiles: [],
            remark: '',
            specification: item.specification,
            rootCategoryLevelId: item.categoryLevelPathIdParent,
            extInfo: item.extInfo
          });
        });

        let _arr =
          this.tableData.taskParam[this.currentIndex].materialQuota.concat(
            array
          );
        let uniqueArray = [];

        uniqueArray = _arr.reduce((acc, current) => {
          const existing = acc.find((item) => item.id === current.id);
          if (!existing) {
            acc.push(current);
          }
          return acc;
        }, []);

        this.tableData.taskParam[this.currentIndex].materialQuota = uniqueArray;

        this.$refs.materialTable.setData(
          this.tableData.taskParam[this.currentIndex].materialQuota
        );
      },

      isValueANumber(variable) {
        if (variable === undefined || variable === null) {
          return false; // 变量没有值
        }
        if (typeof variable === 'number') {
          return true; // 基本类型的数字
        }
        if (
          (typeof variable === 'string' &&
            !isNaN(variable) &&
            !variable.includes('.')) ||
          (variable.includes('.') && !variable.endsWith('.'))
        ) {
          // 字符串类型的数字（注意：这个正则表达式判断较为简单，可能需要根据实际情况调整）
          // 或者使用 Number.isFinite(parseFloat(variable)) 来代替这部分逻辑，但要注意性能开销和边缘情况
          const num = Number(variable);
          return !isNaN(num) && isFinite(num);
        }
        return false; // 其他类型
      },

      add() {
        let subCode = '0010';
        let type = '';
        if (this.activeName === '材料定额') {
          this.$refs.productMultipleRefs.open(1);
          return;
        } else if (this.activeName === '标准产出') {
          this.$refs.standardOutputRefs.open(9);
          return;
        } else if (this.activeName === '关键设备') {
          this.$refs.standardOutputRefs.open(4);
          return;
        } else if (this.activeName === '制造资源') {
          type = 'resource';
        }
        console.log(this.tableData.taskParam[this.currentIndex]);
        if (this.tableData.taskParam[this.currentIndex][type].length) {
          let max =
            Math.max(
              ...this.tableData.taskParam[this.currentIndex][type].map(
                (i) => i.subCode
              )
            ) +
            10 +
            '';

          if (max.length < 4) {
            max = new Array(4 - max.length).fill('0').join('') + max;
          }
          subCode = max.substring(0, max.length - 1) + '0';
        }

        this.tableData.taskParam[this.currentIndex][type].push({
          subCode,
          bomArtFiles: [],
          categoryId: '',
          categoryName: '',
          isReworkBom: 0,
          brandNum: '',
          count: '',
          modelType: '',
          unit: '',
          rootCategoryLevelId: '',
          categoryCode: '',
          specification: '',
          id: ''
        });
      },
      /* 表格数据源 */
      async datasource() {
        return [];
      },
      tabsChange() {
        console.log(this.activeName);
        console.log(this.tableData.taskParam[this.currentIndex]);

        if (this.activeName === '工艺参数') {
          // 工艺参数
          this.$refs.table.setData(
            this.tableData.taskParam[this.currentIndex].produceList || []
          );
        } else if (this.activeName === '质检项参数') {
          this.qualityParam =
            this.tableData.taskParam[this.currentIndex].qualityParam || [];
        } else if (this.activeName === '生产节拍') {
          this.beatParam =
            this.tableData.taskParam[this.currentIndex].beatParam ||
            this.beatParam;
        } else if (this.activeName === '材料定额') {
          this.$refs.materialTable.setData(
            this.tableData.taskParam[this.currentIndex].materialQuota || []
          );
        } else if (this.activeName === '制造资源') {
          this.$refs.resourceTable.setData(
            this.tableData.taskParam[this.currentIndex].resource || []
          );
        } else if (this.activeName === '工种') {
          if (
            JSON.stringify(
              this.tableData.taskParam[this.currentIndex].aptitudeParam
            ) == '{}'
          ) {
            this.tableData.taskParam[this.currentIndex].aptitudeParam = [];
            this.$refs.jobTable.setData([]);
          } else {
            this.$refs.jobTable.setData(
              this.tableData.taskParam[this.currentIndex].aptitudeParam
            );
          }
        } else if (this.activeName === '工艺文件') {
          if (
            JSON.stringify(
              this.tableData.taskParam[this.currentIndex].fileParam
            ) == '{}'
          ) {
            this.tableData.taskParam[this.currentIndex].fileParam = [];
            this.$refs.fileTable.setData([]);
          } else {
            let fileId = this.tableData.taskParam[this.currentIndex].fileParam;
            console.log('111111');
            if (fileId.length > 0) {
              this.fileParamDatasource(fileId);
            }
            // this.$refs.fileTable.setData(
            //   this.tableData.taskParam[this.currentIndex].fileParam
            // );
          }
        } else if (this.activeName === '标准产出') {
          this.$refs.standard.setData(
            this.tableData.taskParam[this.currentIndex].standardOutput || []
          );
        } else if (this.activeName === '关键设备') {
          this.$refs.deviceTabRef.setData(
            this.tableData.taskParam[this.currentIndex].standardDevice || []
          );
        }
      },
      openParam(type) {
        let tableData = [];
        if (type === '工艺') {
          tableData = this.$refs.table.getData();
        } else {
          tableData = this.$refs.qualityTable.getData();
        }
        this.$refs.paramRefs.open(tableData);
      },
      chooseModal(data) {
        let dom = null;
        if (this.activeName === '工艺参数') {
          dom = this.$refs.table;
        }
        dom.setData([...data, ...dom.getData()]);
        this.$set(
          this.tableData.taskParam[this.currentIndex],
          this.activeName === '工艺参数' ? 'produceList' : '',
          dom.getData()
        );
      },

      chooseStandardList(type, data) {
        let dom = null;

        if (type == 9) {
          dom = this.$refs.standard;
          dom.setData([data[0]]);

          this.$set(
            this.tableData.taskParam[this.currentIndex],
            'standardOutput',
            dom.getData()
          );
        } else if (type == 4) {
          dom = this.$refs.deviceTabRef;
          dom.setData([data[0]]);

          this.$set(
            this.tableData.taskParam[this.currentIndex],
            'standardDevice',
            dom.getData()
          );
        }
      },
      remove(row, type) {
        let dom = null;
        if (type === '工艺') {
          dom = this.$refs.table;
        } else {
          dom = this.$refs.qualityTable;
        }
        const data = dom.getData();
        if (row.id) {
          dom.setData(data.filter((d) => d.id !== row.id));
        } else {
          dom.setData(data.filter((d) => d.paramId !== row.paramId));
        }
        this.$set(
          this.tableData.taskParam[this.currentIndex],
          type === '工艺' ? 'produceList' : 'qualityParam',
          dom.getData()
        );
      },
      open(rowData, treeData, tableData, isView, attributeData, resourceBomId) {
        this.columns = [];
        this.columns1 = [];
        this.isView = isView; //true详情 false编辑
        this.resourceBomId = resourceBomId;
        this.attributeData = attributeData;

        if (this.attributeData) {
          this.form.baseCount = this.attributeData.baseCount;
        } else {
          this.form.baseCount = 1;
        }

        if (!this.isView) {
          this.columns = this.defaultColumns.concat({
            columnKey: 'action',
            label: '操作',
            align: 'center',
            resizable: false,
            slot: 'action',
            showOverflowTooltip: true
          });

          this.columns1 = this.defaultColumns1.concat({
            action: 'action',
            slot: 'action',
            label: '操作'
          });
        } else {
          this.columns = this.defaultColumns;
          this.columns1 = this.defaultColumns1;
        }
        this.rowData = JSON.parse(JSON.stringify(rowData));
        this.treeData = JSON.parse(JSON.stringify(treeData));
        this.tableData = JSON.parse(JSON.stringify(tableData));
        this.currentIndex = tableData.taskParam.findIndex(
          (item) => item.id === rowData.id
        );
        this.activeName = '工艺参数';

        // this.baseCount = rowData.baseCount;
        // this.baseCountUnit = rowData.baseCountUnit;

        console.log(rowData, 'rowData');

        // this.form.baseCount = rowData.baseCount || 1;
        this.form.baseCountUnit = rowData.baseCountUnit;

        this.baseCount2 = rowData.baseCount2;
        this.baseCountUnit2 = rowData.baseCountUnit2;

        this.visible = true;
        setTimeout(() => {
          console.log(this.$refs);
          // 工艺参数
          this.$refs.table.setData(
            this.tableData.taskParam[this.currentIndex].produceList
          );
        }, 500);

        this.getBomLevel();
      },

      async getBomLevel() {
        await getBomGetById(this.resourceBomId).then((res) => {
          if (res.data.level) {
            this.level = res.data.level;
          }
        });
      },

      handleClose() {
        this.visible = false;
        this.$refs.table.setSelectedRows([]);
        this.selection = [];
      },
      save(type) {
        if (this.activeName == '材料定额') {
        }

        this.$refs.form.validate((valid) => {
          let isYs = true;
          if (this.activeName == '材料定额') {
            isYs = valid;
          }
          if (isYs) {
            if (this.isView) {
              this.handleClose();
            } else {
              // 保存生产节拍
              let userInfo = JSON.parse(localStorage.getItem('info'));
              this.beatParam.createName = userInfo.name;
              this.beatParam.createTime = dayjs(new Date()).format(
                'YYYY-MM-DD HH:mm:ss'
              );
              this.beatParam.updateName = userInfo.name;
              this.beatParam.updateTime = dayjs(new Date()).format(
                'YYYY-MM-DD HH:mm:ss'
              );
              this.tableData.taskParam[this.currentIndex].beatParam =
                this.beatParam;
              // 保存标准工时

              // 保存材料定额
              this.tableData.taskParam[this.currentIndex].baseCount =
                this.form.baseCount;
              this.tableData.taskParam[this.currentIndex].baseCountUnit =
                this.form.baseCountUnit;

              this.tableData.taskParam[this.currentIndex].baseCount2 =
                this.baseCount2;
              this.tableData.taskParam[this.currentIndex].baseCountUnit2 =
                this.baseCountUnit2;

              if (this.$refs.qualityParamRef) {
                this.tableData.taskParam[this.currentIndex].qualityParam =
                  this.$refs.qualityParamRef.getDate() || [];
              }
              //工艺文件只传id
              let fileParamArr = JSON.parse(
                JSON.stringify(this.tableData.taskParam)
              );
              fileParamArr.map((item, index) => {
                if (item.fileParam.length > 0) {
                  let val = [];
                  item.fileParam.map((fileItem) => {
                    let obj = {
                      id: fileItem.id
                    };
                    val.push(obj);
                  });
                  this.$set(this.tableData.taskParam[index], 'fileParam', val);
                }
              });
              console.log('111112223344', this.tableData.taskParam);
              workingProcedureUpdate({
                id: this.tableData.id,
                categoryId: this.treeData.categoryId,
                bomCategoryId: this.treeData.id,
                categoryCode: this.treeData.categoryCode,
                taskParam: this.tableData.taskParam
              }).then(() => {
                this.$message.success('保存成功');
                this.$emit('chooseProcess');
                if (type === 'close') {
                  this.handleClose();
                }
              });
            }
          }
        });
      },

      //工艺文件表格回显
      fileParamDatasource(fileParam) {
        let fileId = fileParam.map((item) => item.id).join(',');
        newFilePageAPI({
          // pageNum: 1,
          // size: 999,
          // directoryId: null,
          // lcyStatus: 1,
          // fileType: 0,
          // ids: fileId
          ids: "'" + fileId + "'"
        }).then((res) => {
          this.$refs.fileTable.setData(res);
        });
      },

      async getDictList(code) {
        let { data: res } = await getByCode(code);

        this.dictList = res.reduce((acc, curr) => {
          let key = Object.keys(curr)[0]; // 获取当前对象的键
          let value = curr[key]; // 获取当前对象的值
          acc.push({ value, label: value }); // 将 { value, label } 格式的对象添加到数组中
          return acc;
        }, []); // 初始值为空数组 []
      },

      convertToSeconds(time) {
        switch (this.beatParam.unit) {
          case '秒':
            return time;
          case '分钟':
            return time * 60;
          case '小时':
            return time * 3600;
          case '天':
            return time * 86400; // 24小时 * 60分钟 * 60秒
          case '月':
            // 近似值，一个月按30天计算
            return time * 86400 * 30;
          case '年':
            // 近似值，一年按365天计算
            return time * 86400 * 365;
          case '毫秒':
            return time / 1000;
          case '微秒':
            return time / 1000000;
          default:
            this.$message.error('不支持的时间单位: ' + unit);
        }
      },

      convertVal(val, name) {
        if (!this.beatParam.unit) {
          return this.$message.error('请选择时间单位');
        }

        const isNumeric = /^\d*(\.\d+)?$/.test(val);
        if (isNumeric) {
          this.beatParam[name] = this.convertToSeconds(val);
        } else {
          this.$message.error('请输入数字');
          this.beatParam[name] = '';
        }
      },

      changeUnit() {
        this.beatParam.newTime = '';
        this.beatParam.time = '';
        this.beatParam.newBeatPrepareTime = '';
        this.beatParam.beatPrepareTime = '';
        this.beatParam.newBeatTime = '';
        this.beatParam.beatTime = '';
        this.beatParam.newBeatRestTime = '';
        this.beatParam.beatRestTime = '';
        this.beatParam.taskPrice = '';
      },

      handSubstitution(row) {
        this.$refs.replaceMaterialRef.open(row);
      },
      replaceSelected(id, list) {
        let _arr = [];
        _arr = this.tableData.taskParam[this.currentIndex].materialQuota;
        _arr.forEach((item) => {
          if (item.id === id) {
            item.replaceMaterial = list;
          }
        });
        this.tableData.taskParam[this.currentIndex].materialQuota = _arr;
      }
    }
  };
</script>

<style lang="scss" scoped>
  .btns {
    text-align: center;
    padding: 10px 0;
  }

  .downLoad {
    display: flex;
  }

  .toolbar_box {
    float: right;
    margin-right: 10px;

    > div {
      display: flex;
      align-items: center;
      justify-content: center;

      > span {
        width: 150px;
      }

      > div {
        margin-left: 10px;
      }
    }
  }
  .item-height {
    margin-bottom: 20px;
  }
</style>
